Minimum spanning tree for each edge CodeForces - 609E

2024-02-22 19:08

本文主要是介绍Minimum spanning tree for each edge CodeForces - 609E,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

点击打开链接

先求最小生成树的边 这些边的对应值就是生成树的权值 再用这些边建图 对所有非生成树上的边的两点 去掉两者路径上的最长边 然后换为当前边的权值 这个过程求个lca即可

这应该是贪心 最小生成树已经是最优解(克鲁斯卡尔方法中 就是从小边找起 感觉也有贪心的意思) 每换下任何一条边都会增加权重(可能不变) 既然非要换至少一条边 那就只换一条就够了

#include <bits/stdc++.h>
using namespace std;
#define ll long longstruct node1
{int id;int u;int v;ll w;ll ans;
};struct node2
{int v;ll w;int next;
};node1 pre[200010];
node2 edge[400010];
ll maxx[200010][20];
int dp[200010][20];
int first[200010],f[200010],book[200010],deep[200010];
int n,m,num;bool cmpI(node1 n1,node1 n2)
{return n1.w<n2.w;
}bool cmpII(node1 n1,node1 n2)
{return n1.id<n2.id;
}void addedge(int u,int v,ll w)
{edge[num].v=v;edge[num].w=w;edge[num].next=first[u];first[u]=num++;return;
}int getf(int p)
{if(f[p]==p) return p;else{f[p]=getf(f[p]);return f[p];}
}bool unite(int u,int v)
{int fu,fv;fu=getf(u);fv=getf(v);if(fu!=fv){f[fv]=fu;return true;}else return false;
}void dfs(int cur,int pre)
{ll w;int i,v;for(i=first[cur];i!=-1;i=edge[i].next){v=edge[i].v,w=edge[i].w;if(v!=pre){dp[v][0]=cur;maxx[v][0]=w;deep[v]=deep[cur]+1;dfs(v,cur);}}return;
}void solve()
{int i,j;memset(dp,0,sizeof(dp));memset(maxx,0,sizeof(maxx));memset(deep,0,sizeof(deep));dp[1][0]=1;deep[1]=1;dfs(1,-1);for(j=1;(1<<j)<=n;j++){for(i=1;i<=n;i++){dp[i][j]=dp[dp[i][j-1]][j-1];maxx[i][j]=max(maxx[i][j-1],maxx[dp[i][j-1]][j-1]);}}return;
}int getlca(int u,int v)
{int i;if(deep[u]<deep[v]) swap(u,v);for(i=log2(n);i>=0;i--){if(deep[dp[u][i]]>=deep[v]){u=dp[u][i];}}if(u==v) return u;for(i=log2(n);i>=0;i--){if(dp[u][i]!=dp[v][i]){u=dp[u][i];v=dp[v][i];}}return dp[u][0];
}ll getmax(int p,int lca)
{ll res;int i;res=0;for(i=log2(n);i>=0;i--){if(deep[dp[p][i]]>=deep[lca]){res=max(res,maxx[p][i]);p=dp[p][i];}}return res;
}int main()
{ll sum;int i,cnt,lca;while(scanf("%d%d",&n,&m)!=EOF){for(i=1;i<=m;i++){pre[i].id=i;scanf("%d%d%lld",&pre[i].u,&pre[i].v,&pre[i].w);}for(i=1;i<=n;i++){f[i]=i;}memset(book,0,sizeof(book));sort(pre+1,pre+m+1,cmpI);cnt=0,sum=0;for(i=1;i<=m;i++){if(unite(pre[i].u,pre[i].v)){book[i]=1;cnt++,sum+=pre[i].w;}if(cnt==n-1) break;}memset(first,-1,sizeof(first));num=0;for(i=1;i<=m;i++){if(book[i]){addedge(pre[i].u,pre[i].v,pre[i].w);addedge(pre[i].v,pre[i].u,pre[i].w);pre[i].ans=sum;}}solve();for(i=1;i<=m;i++){if(!book[i]){lca=getlca(pre[i].u,pre[i].v);int res=max(getmax(pre[i].v,lca),getmax(pre[i].u,lca));pre[i].ans=sum-res+pre[i].w;}}sort(pre+1,pre+m+1,cmpII);for(i=1;i<=m;i++){printf("%lld\n",pre[i].ans);}}return 0;
}

 

这篇关于Minimum spanning tree for each edge CodeForces - 609E的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/736212

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

树(Tree)——《啊哈!算法》

树 什么是树?树是一种特殊的图,不包含回路的连通无向树。 正因为树有着“不包含回路”这个特点,所以树就被赋予了很多特性。 一棵树中的任意两个结点有且仅有唯一的一条路径连通。一棵树如果有n个结点,那么它一定恰好有n-1条边。在一棵树中加一条边将会构成一个回路。 一棵树有且只有一个根结点。 没有父结点的结点称为根结点(祖先)。没有子结点的结点称为叶结点。如果一个结点既不是根结点也不是叶

226 Invert Binary Tree

//226 Invert Binary Tree//算法思路:主要使用递归算法public class Solution {public TreeNode invertTree(TreeNode root) {//1 出口 空节点if (root==null)return null;//2 递归 调用自己TreeNode left = root.left;TreeNode right = ro

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

【Hdu】Minimum Inversion Number(逆序,线段树)

利用线段树在nlogn的时间复杂度内求一段数的逆序。 由于给的序列是由0 ~ n -1组成的,求出初始的逆序之后可以递推出移动之后的逆序数。 #include<cstdio>#include<iostream>#include<cstring>#include<algorithm>using namespace std;typedef long long LL;const in

Codeforces#295(Div.2)A、B(模拟+BFS)

解题报告链接:点击打开链接 C. 题目链接:点击打开链接 解题思路: 对于给定的字符串,取出现次数最多的字母(可以同时有多个)。由这些字母组成长度为n的字符串,求有多少种组合。最后用数学知识即可。 完整代码: #include <algorithm>#include <iostream>#include <cstring>#include <climits>